const system = require("../../../system");
const ServiceBase = require("../../sve.base")
const settings = require("../../../../config/settings")
const jwt = require('jsonwebtoken');
class UserService extends ServiceBase {
  constructor() {
    super("auth", ServiceBase.getDaoName(UserService));
    this.companyDao=system.getObject("db.common.companyDao");
  }

  //注册接口
  //封装kongurl
  async register(p,q){
    var self=this;
    let tmppwd=p.password;
    if(!tmppwd){
      tmppwd=settings.defaultpwd;
    }
    p.password=this.getEncryptStr(tmppwd);
    return  this.db.transaction(async function (t) {
      //创建一个默认公司,公司名称xxxx的公司
      let cmp=await self.companyDao.create({name:p.userName+"的公司"},t);
      p.company_id=cmp.id;
      let u=await self.dao.create(p,t)
      //创建统一账号
      let cred=await self.cregister(u.userName,cmp.id)
      console.log("......................................");
      console.log(cred.consumer.id);
      if(cred){
         u.center_id=cred.consumer.id;
         u.jwtkey=cred.key;
         u.jwtsecret=cred.secret;
         try{
          await u.save({transaction:t});
         }catch(e){
           console.log(e);
          await self.cunregister(p.userName);
          throw new Error("保存用户失败");
         }
        return u;
      }else{
        throw new Error("创建统一账号失败");
      }
    });
  }

  //登录接口封装kong-url
  //登录路由放行
  //p里面含有appkey,company_id,userName,password
  async login(p,q){
    var self=this;
    var rtn={}
    return  this.db.transaction(async function (t) {
        p.password=this.getEncryptStr(p.password);
        let userfind=await self.dao.findOne(p);
        if(userfind){
            let token= self.cmakejwt(userfind.jwtkey,userfind.jwtsecret,null);
            rtn.token=token;
            rtn.user=userfind;
            return rtn;
        }else{
            return null;
        }
    })
  }
  //用户验证码登录
  //
  async loginByVCode(p,q,req){
    var rtn={}
    //检查传递过来的手机验证码是否与缓存的一致
     let mobile=p.mobile;
     let vcode=p.vcode;
     let cachevcode=await this.cacheManager ["vcodeCache"].getCache(mobile,60000)
     if(vcode!==cachevcode){
       return null;
     }else{
       //检查是否在库里存在
       //appkey--company_id---需要控制器基类里设置到p对象里
       let user=await this.findOne({userName:mobile,appkey:p.appkey,company_id:p.company_id})
       if(user){
         //生成token
       }else{
         //先按照用户名查续身份信息，获取key,secret,
         let u=await this.register({userName:mobile,appkey:p.appkey,company_id:p.company_id});

       }
     }
    //不一致那么就

  }
  //发送手机验证码并缓存
  async sendVCode(p,q,req){
      let mobile=p.mobile;
      let vcodeobj=this.cacheManager ["vcodeCache"].cache(mobile,null,60000);
      return vcodeobj.vcode;
  }
  async reSendVCode(p,q,req){
    let mobile=p.mobile;
    await this.cacheManager ["vcodeCache"].invalidate(mobile);
    let vcodeobj=await this.cacheManager ["vcodeCache"].cache(mobile,null,60000);
    return vcodeobj.vcode;
}

  //创建统一账号及jwt身份
  async cregister(uname,cmpid){
    try{
      var rtn2=null;
      let rtn=await system.postJsonTypeReq(UserService.newConsumerUrl(),{username:uname,tags:["cmp_"+cmpid]})
      console.log(rtn)
      if(rtn.statusCode==409){
        throw new Error("已经存在相同的统一账号名称!");
      }else{
          //创建身份
          rtn2=await system.post3wFormTypeReq(UserService.newJwtCredUrl(uname))
      }
      if(rtn.statusCode==201 && rtn2.statusCode==201){
        return rtn2.data;
      }
      return null;
    }catch(e){
      console.log(e);
      return  null;
    }
  }
  async jwtsign(plkey,secretstr,opts){
     let promise=new Promise(function(resv,rej){
         jwt.sign({ iss: plkey },secretstr,opts,function(err,rtn){
           if(err){
             rej(err);
           }else{
            resv(rtn);
           }
         });
     });
     return promise;
  }
  //只要登录 生成新的访问jwttoken
  async cmakejwt(uname,opts){
    var token =await  this.jwtsign('a36c3049b36249a3c9f8891cb127243c', 'e71829c351aa4242c2719cbfbe671c09',opts);
    return token;
  }

  //删除统一账号
    async cunregister(uname){
      try{
        let rtn=await system.delReq(UserService.consumerUrl(uname))
        if(rtn.statusCode==204){
          return {};
        }
        return null;
      }catch(e){
        return  null;
      }
    }

  //登录统一账号
  async clogin(uname){
    //检查是否存在重名

  }
  //按用户名查询统一用户
  async findCUser(uname){

  }
}

module.exports = UserService;
// (async ()=>{
   let u=new UserService();
//   //  let x=await u.cregister("jiangong")
//   //  console.log(x)
//   // let x=await u.cunregister("jiangong")
//   //  console.log(x)
//   // let t=await u.cmakejwt()
//   // console.log(t)
  let ux=u.register({userName:"jiangyong3",password:"123"})
  console.log(ux);
// })()